package de._82grfl1bif.KPI_Visualizer.structures;

import org.bukkit.Material;

import javax.persistence.Column;

public class Building extends Structure{
    @Column(name = "height")
    private final int height;

    public Building(int width, int height, Material material){ //Buildings are Square -> no depth
        this.width = width;
        this.height = height;
        this.material = material;
        if(this.width < 3){
            throw new IllegalArgumentException("keine Gebäude kleiner 3 wegen 2 gehweg");
        }
    }

    public int getHeight() {
        return this.height;
    }
}
